#include "keyscan_edit.h"
#include <tigcclib.h>
Keystat keystat;
Keystat oldkeystat;
void (*keyscan) (void) = keyscan_89;

void
keyscan_init (void)
{
  if (!CALCULATOR)
    {
      keyscan = keyscan_89;
    }
  else
    {
      keyscan = keyscan_92p;
    }
}

void
keyscan_89 (void)
{
  unsigned char row0, row6;
  memcpy (&oldkeystat, &keystat, sizeof keystat);
  row0 = _rowread (~0x0001);
  keystat.up = row0 & 0x01;
  keystat.down = row0 & 0x04;
  keystat.left = row0 & 0x02;
  keystat.right = row0 & 0x08;
  keystat.second = row0 & 0x10;
  keystat.shift = row0 & 0x20;
  keystat.diamond = row0 & 0x40;
  row6 = _rowread (~((short) (1 << 6)));
  keystat.escape = row6 & 0x01;
}

void
keyscan_92p (void)
{
//TI-89         | TI-92+
//2nd           | Shift
//Shift         | Z
//Diamond       | Diamond
  unsigned char row0, row1, row8;
  memcpy (&oldkeystat, &keystat, sizeof keystat);
  row0 = _rowread (~0x0001);
  keystat.up = row0 & 0x20;
  keystat.down = row0 & 0x80;
  keystat.left = row0 & 0x10;
  keystat.right = row0 & 0x40;
  keystat.second = row0 & 0x04;
  row1 = _rowread (~0x0002);
  keystat.shift = row1 & 0x02;
  keystat.diamond = row0 & 0x02;
  row8 = _rowread (~0x0100);
  keystat.escape = row8 & 0x40;
}
