@echo off
SET MAJOR=0
SET MINOR=5

SET BASEDRIVE=K:
SET BASEDIR=a3dsdk

SET WINZIPDIR=C:\Program Files\WinZip
SET ZIPDRIVE=K:
SET ZIPPATH=\
SET SDKDIR=a3dsdk_%MAJOR%_%MINOR%
SET GAMEDIR=arena3d_%MAJOR%_%MINOR%
SET SRCDIR=src_%MAJOR%_%MINOR%
SET SETUPDIR=C:\Program Files\Inno Setup 2

rem Rebuild all binaries
call build_all

cd..

rem Remove old release
del /Q ..\%SDKDIR%\*.*
del /Q ..\%GAMEDIR%\*.*
del /Q ..\%SRCDIR%\*.*
rmdir /Q /S ..\%SDKDIR%
rmdir /Q /S ..\%GAMEDIR%
rmdir /Q /S ..\%SRCDIR%

rem Copy over game and SDK contents
xcopy /e /y /EXCLUDE:src\exclude_sdk.txt *.* ..\%SDKDIR%\
xcopy /e /y /EXCLUDE:src\exclude_game.txt *.* ..\%GAMEDIR%\
xcopy /e /y FolderChg* ..\%GAMEDIR%
xcopy /e /y finalize* ..\%GAMEDIR%
%ZIPDRIVE%
cd\
cd %SRCDIR%
mkdir src
%ZIPDRIVE%
cd\
cd %BASEDIR%
cd src
xcopy /e /y *.* ..\..\%SRCDIR%\src\

rem Make ZIP files
%BASEDRIVE%
cd\
cd %BASEDIR%
del src.zip
"%WINZIPDIR%\wzzip.exe" -r -p src.zip %BASEDRIVE%\%SRCDIR%\*.*
move src.zip %BASEDRIVE%\%GAMEDIR%\src.zip
del /Q %BASEDRIVE%\%SRCDIR%\*.*
del /Q %BASEDRIVE%\%GAMEDIR%\src\*.*
rmdir /Q /S %BASEDRIVE%\%GAMEDIR%\src
%ZIPDRIVE%
cd\
cd %ZIPPATH%
del a3dsdk.zip
del arena3d.zip
"%WINZIPDIR%\wzzip.exe" -r -p arena3d.zip %GAMEDIR%\*.*
%BASEDRIVE%
cd\
cd %BASEDIR%
"%SETUPDIR%\iscc.exe" a3dsdk.iss
%ZIPDRIVE%
cd\
cd %ZIPPATH%
"%WINZIPDIR%\wzzip.exe" -r -p a3dsdk.zip a3dsdk.exe

rem Remove new release
%BASEDRIVE%
cd\
del /Q %SDKDIR%\*.*
del /Q %GAMEDIR%\*.*
del /Q %SRCDIR%\*.*
del /Q %SRCDIR%\*.*
del /Q %SRCDIR%\*.*
rmdir /Q /S %SDKDIR%
rmdir /Q /S %GAMEDIR%
rmdir /Q /S %SRCDIR%
rmdir /Q /S %SDKDIR%
rmdir /Q /S %GAMEDIR%
rmdir /Q /S %SRCDIR%

@echo on
pause