// C Header File
// Created 9/14/2002; 3:29:07 PM

void dissolve (void);
void InitGUI (void);
short RayBlocked (FATCONFIG * fc, short x1, short y1, short x2, short y2);

void
CheckPlayerDeath (FATCONFIG * fc, short dead, short killer)
{
  short r =
    ((random ((MAX_PLAYERS + 1) * 2)) & ~1) + gamedata.player[dead].team;
  if (gamedata.player[dead].health <= 0)
    {

      if (dead == REAL_PLAYER_IDX)
	{
	  dissolve ();
	  score.already_used = 0;
	  health.already_used = 0;
	}

      gamedata.player[dead].health = 100;
      gamedata.player[dead].spr->xpos = respawns[r].x * 64 + 32;
      gamedata.player[dead].spr->ypos = respawns[r].y * 64 + 32;
      switch (gamedata.gametype)
	{
	case DM:
	  gamedata.player[dead].desire = ENEMY_DM_WALK;
	  break;
	case TEAM:
	  gamedata.player[dead].desire = ENEMY_TEAM_WALK;
	  break;
	case CTF:
	  gamedata.player[dead].desire = ENEMY_CTF_WALK;
	  break;
	}
      gamedata.player[dead].rocket_multiplier = MULTIPLIER_DIVISOR;
      if (killer == dead)
	{
	  gamedata.player[killer].score--;
	  gamedata.invert = 0;
	}

      else
	{
	  gamedata.player[killer].score++;	// * (below)
	  if (gamedata.gametype != DM)
	    {
	      if (gamedata.player[killer].team == gamedata.player[dead].team)
		{
		  gamedata.player[killer].score -= 2;	//Really -1, but +1 was already added
		}
	      else if (gamedata.gametype == TEAM)
		gamedata.team[gamedata.player[killer].team].score++;
	    }

	}
      if (gamedata.gametype == CTF)
	{
	  if ((gamedata.flag[WHITE_TEAM].inuse
	       && gamedata.flag[WHITE_TEAM].player_idx == dead))
	    {
	      ResetFlag (WHITE_TEAM);
	      gamedata.player[killer].score += FLAG_RETURN - 1;	//+ *(above)=FLAG_RETURN
	    }
	  else
	    if ((gamedata.flag[GRAY_TEAM].inuse
		 && gamedata.flag[GRAY_TEAM].player_idx == dead))
	    {
	      ResetFlag (GRAY_TEAM);
	      gamedata.player[killer].score += FLAG_RETURN - 1;	//+ *(above)=FLAG_RETURN
	    }
	}


      if (gamedata.gametype == DM
	  && gamedata.player[killer].score == gamedata.scorelimit
	  && gamedata.scorelimit > 0)
	{
	  gamedata.quitting = 2;
	}
      else if (gamedata.gametype == TEAM &&
	       gamedata.team[gamedata.player[killer].team].score ==
	       gamedata.scorelimit && gamedata.scorelimit > 0)
	{
	  gamedata.quitting = 2;
	}

      if (dead == REAL_PLAYER_IDX)
	{
	  InitGUI ();
	  fc->cam_xpos = gamedata.player[REAL_PLAYER_IDX].spr->xpos;
	  fc->cam_ypos = gamedata.player[REAL_PLAYER_IDX].spr->ypos;

	}

    }
}

#define SPRITE_WIDTH  40
#define SPRITE_HEIGHT 64


#define MAXDAMAGE (gamedata.rocket[rocket_idx].player_idx==REAL_PLAYER_IDX?2*ROCKET_DAMAGE:ROCKET_DAMAGE)
#define MAXDELTA ((SPRITE_HEIGHT/2)/(64/SPRITE_WIDTH))


void
SpawnRocket (FATCONFIG * fc, short player_idx)
{
  FATSPRITE *cursprite;
  short rocket_idx;

  fc = fc;

  //Check if another rocket is allowed
  if (player_idx)
    {
      if (gamedata.player[player_idx].rocket_idx == MAX_ROCKETS_PER_PLAYER)
	return;
    }
  else if (gamedata.player[player_idx].rocket_idx ==
	   MAX_ROCKETS_PER_PLAYER + REAL_PLAYER_ROCKET_EXTRA)
    return;

  if (gamedata.player[player_idx].rocket_multiplier == 1)
    return;

  //Find a free rocket
  for (rocket_idx = 0; rocket_idx < MAX_ROCKETS; rocket_idx++)
    {
      if (gamedata.rocket[rocket_idx].inuse == SPRITE_FREE)
	break;
    }
  if (rocket_idx == MAX_ROCKETS)
    return;





  //-------------------------------------------------------------------------
  // initialize sprite structure and setup its fields
  //-------------------------------------------------------------------------
  cursprite = &gamedata.rocket[rocket_idx].spr;
  FAT_InitSprite (cursprite);
  if (gamedata.instagib)
    cursprite->drawmode = SPRITEMODE_UNUSED;
  else
    cursprite->drawmode = SPRITEMODE_SIZE64;
  cursprite->nr_textures = 8;
  cursprite->textures = (TEXCONFIG *) model_tex + SPRIDX_rocket1;
  cursprite->orientation = gamedata.player[player_idx].spr->orientation;
  cursprite->xpos = gamedata.player[player_idx].spr->xpos;
  cursprite->ypos = gamedata.player[player_idx].spr->ypos;
  cursprite->xpos += ((FAT_Cos16384 (cursprite->orientation) >> 9) *
		      ROCKET_SPEED) >> 2;
  cursprite->ypos += ((FAT_Sin16384 (cursprite->orientation) >> 9) *
		      ROCKET_SPEED) >> 2;
  if (fc->
      map_data[(cursprite->ypos >> 6) * fc->map_width +
	       (cursprite->xpos >> 6)] > 0)
    {
      cursprite->xpos = gamedata.player[player_idx].spr->xpos;
      cursprite->ypos = gamedata.player[player_idx].spr->ypos;
    }
  gamedata.rocket[rocket_idx].inuse = SPRITE_INUSE;
  gamedata.rocket[rocket_idx].player_idx = player_idx;
  gamedata.rocket[rocket_idx].multiplier =
    gamedata.player[player_idx].rocket_multiplier;
  gamedata.player[player_idx].multiplier_count = MULTIPLIER_DIVISOR;
  gamedata.player[player_idx].rocket_idx++;
  gamedata.sprites.rockets++;
}

void
KillRocket (short rocket_idx)
{



  if (gamedata.rocket[rocket_idx].player_hit_idx != REAL_PLAYER_IDX)
    {
      gamedata.rocket[rocket_idx].inuse = -1;	//To start showing the explosion pix
      gamedata.rocket[rocket_idx].spr.drawmode = SPRITEMODE_SIZE64;
      gamedata.rocket[rocket_idx].spr.nr_textures = 1;
    }
  else
    {
      gamedata.rocket[rocket_idx].inuse = -1;
      gamedata.rocket[rocket_idx].spr.nr_textures = 1;
      gamedata.rocket[rocket_idx].spr.drawmode = SPRITEMODE_UNUSED;
      gamedata.invert = 1;
    }


  if (gamedata.rocket[rocket_idx].player_hit_idx ==
      gamedata.rocket[rocket_idx].player_idx)
    {
      gamedata.player[gamedata.rocket[rocket_idx].player_hit_idx].
	last_hit_dir = gamedata.rocket[rocket_idx].spr.orientation;
    }
  else
    {
      gamedata.player[gamedata.rocket[rocket_idx].player_hit_idx].
	last_hit_dir =
	FAT_ClampAngle (gamedata.rocket[rocket_idx].spr.orientation -
			ANGLE_180);
    }

}

short
RocketCollision (FATCONFIG * fc, short rocket_idx)
{
#define HIT_DISTANCE 32+ROCKET_SPEED
#define WALL_SPLASH 100
  short x = gamedata.rocket[rocket_idx].spr.xpos +
    ((FAT_Cos16384 (gamedata.rocket[rocket_idx].spr.orientation) >> 11) *
     ROCKET_SPEED);
  short y =
    gamedata.rocket[rocket_idx].spr.ypos +
    ((FAT_Sin16384 (gamedata.rocket[rocket_idx].spr.orientation) >> 11) *
     ROCKET_SPEED);
  short location = (y >> 6) * fc->map_width + (x >> 6);
  long distance_squared;
  unsigned long distance;
  long dx;
  long dy;
  short a;
  short maxangle;
  short damage;

//Check if it hit a wall
  if (fc->map_data[location] > 0)
    {
      for (a = gamedata.sprites.players; a >= 0; a--)
	{

	  dx = (long) x - gamedata.player[a].spr->xpos;
	  dy = (long) y - gamedata.player[a].spr->ypos;
	  dx *= dx;
	  dy *= dy;
	  distance_squared = dx + dy;
	  distance = FAT_FastSqrt (distance_squared);

	  if (distance <= (unsigned long) WALL_SPLASH)
	    {
	      if (!RayBlocked (fc,
			       gamedata.rocket[rocket_idx].spr.xpos,
			       gamedata.rocket[rocket_idx].spr.ypos,
			       gamedata.player[a].spr->xpos,
			       gamedata.player[a].spr->ypos))
		{
#define WALL_DAMAGE (ROCKET_DAMAGE*2)
		  damage =
		    (signed short) (WALL_DAMAGE *
				    (WALL_SPLASH -
				     (signed short) distance) / WALL_SPLASH);
		  damage *=
		    gamedata.player[gamedata.rocket[rocket_idx].player_idx].
		    rocket_multiplier;

		  if (gamedata.player[gamedata.rocket[rocket_idx].player_idx].
		      team != gamedata.player[a].team)
		    damage /= 2;

		  gamedata.player[a].health -= damage;
		  gamedata.rocket[rocket_idx].player_hit_idx = a;
		  CheckPlayerDeath (fc,
				    gamedata.rocket[rocket_idx].
				    player_hit_idx,
				    gamedata.rocket[rocket_idx].player_idx);
		  return 1;
		}

	    }


	}
      gamedata.rocket[rocket_idx].player_hit_idx = 1;
      return 1;
    }

//Check if it hit a player
  for (a = gamedata.sprites.players; a >= 0; a--)
    {
      dx = x - gamedata.player[a].spr->xpos;
      dy = y - gamedata.player[a].spr->ypos;
      distance_squared = dx * dx + dy * dy;
      distance = FAT_FastSqrt (distance_squared);

      if (distance <= (unsigned long) HIT_DISTANCE)
	{


	  FATSPRITE *cursprite =
	    allspr + gamedata.sprites.players + gamedata.sprites.ctfflags;
	  cursprite += gamedata.rocket[rocket_idx].cur_idx;
	  short angle = cursprite->orientation;
	  short bestangle = FAT_GetArcTanYX (gamedata.player[a].spr->ypos - y,
					     gamedata.player[a].spr->xpos -
					     x);
	  short angledelta = abs (angle - bestangle);
	  if (angledelta > ANGLE_180)
	    angledelta = ANGLE_360 - angledelta;

	  maxangle =
	    (gamedata.rocket[rocket_idx].player_idx ==
	     REAL_PLAYER_IDX ? ANGLE_030 * 2 : ANGLE_030);
	  if (angledelta < maxangle)
	    {
	      damage = MAXDAMAGE * (maxangle - angledelta) / maxangle;
	      damage *=
		gamedata.player[gamedata.rocket[rocket_idx].player_idx].
		rocket_multiplier;

	      if (gamedata.player[gamedata.rocket[rocket_idx].player_idx].
		  team != gamedata.player[a].team)
		damage /= 2;

	      gamedata.player[a].health -= damage;
	      gamedata.rocket[rocket_idx].player_hit_idx = a;
	      CheckPlayerDeath (fc,
				gamedata.rocket[rocket_idx].player_hit_idx,
				gamedata.rocket[rocket_idx].player_idx);
	      return 1;
	    }
	}
    }



  return 0;
}

short
RocketsHandle (FATCONFIG * fc)
{
  short a;
  short stepx;
  short stepy;
  short norockets = 1;
  short idx = 0;
  FATSPRITE *cursprite =
    allspr + gamedata.sprites.players + gamedata.sprites.ctfflags;

  fc = fc;

  for (a = 0; a < MAX_ROCKETS; a++)
    {
      if (gamedata.rocket[a].inuse == SPRITE_FREE)
	continue;


      if (gamedata.rocket[a].inuse == SPRITE_INUSE)
	{
	  norockets = 0;
	  if (RocketCollision (fc, a))
	    KillRocket (a);
	  else
	    {
	      stepx =
		((FAT_Cos16384 (gamedata.rocket[a].spr.orientation) >> 9) *
		 ROCKET_SPEED) >> 2;
	      stepy =
		((FAT_Sin16384 (gamedata.rocket[a].spr.orientation) >> 9) *
		 ROCKET_SPEED) >> 2;
	      gamedata.rocket[a].spr.xpos += stepx;
	      gamedata.rocket[a].spr.ypos += stepy;
	    }
	}



      if (gamedata.rocket[a].inuse < SPRITE_FREE)
	{
	  if (gamedata.rocket[a].inuse == -7)
	    {
	      gamedata.rocket[a].inuse = SPRITE_FREE;
	      gamedata.sprites.rockets--;
	      gamedata.player[gamedata.rocket[a].player_idx].rocket_idx--;
	    }
	  else
	    {
	      gamedata.rocket[a].spr.textures =
		(TEXCONFIG *) level_tex + TEXIDX_rex1 +
		abs (gamedata.rocket[a].inuse) - 1;
	      gamedata.rocket[a].inuse--;
	    }
	}
      if (gamedata.rocket[a].inuse != SPRITE_FREE)
	{
	  gamedata.rocket[a].cur_idx = idx;
	  idx++;
	  if (cursprite != allspr + MAX_PLAYERS + MAX_ROCKETS)
	    {
	      memcpy (cursprite, &gamedata.rocket[a].spr, sizeof (FATSPRITE));
	      ++cursprite;
	    }


	}


    }
  if (norockets)
    return 0;
  return 1;
}
